const _my = require("../../__antmove/api/index.js")(my);
const wx = _my;
const { request_wxrlxf } = require("../func/request");

// 人脸下发接口
const doPass = data => {
    return request_wxrlxf({
        url: "/api/next/doGetFacePass",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};

// 查询楼宇列表
const getBuildingList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getBuildingList",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   常客获取楼宇的设备列表(sn和name)
const userWhiteGetSnList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/userWhiteGetSnList",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   根据访客记录Id获取记录
const getVisitoryByUserVisitorListDetailId = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getVisitoryByUserVisitorListDetailId",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   常客邀请访客
const userWhiteInviteUserVisitor = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/alipay/userWhiteInviteUserVisitor",
        data: data,
        method: "post",
        type: "application/json"
    });
};
//  常客登记-查询楼宇内是否存在这个常客
const userWhiteCheck = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/userWhiteCheck",
        data: data,
        method: "post",
        type: "application/json"
    });
};

//  访客预约-查询手机号在该账号内是否是常客
const getUserWhiteByphoneAndAdminId = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getUserWhiteByphoneAndAdminId",
        data: data,
        method: "post",
        type: "application/json"
    });
};

//  访客预约-提交拜访申请
const visitorySubmit = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/alipay/visitorySubmit",
        data: data,
        method: "post",
        type: "application/json"
    });
};
//  企业信息提交审核
const companyCommit = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/alipay/companyCommit",
        data: data,
        method: "post",
        type: "application/json"
    });
};
//   查询企业审核情况
const companyCommitInfoList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/companyCommitInfoList",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   常客查询拜访记录列表
const userWhiteVisitList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/userWhiteVisitList",
        data: data,
        method: "post",
        type: "application/json"
    });
};
//   访客查询拜访记录列表
const visitoryVisitList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/visitoryVisitList",
        data: data,
        method: "post",
        type: "application/json"
    });
};

//   常客处理访客申请记录
const userWhiteHandleVisitList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/alipay/userWhiteHandleVisitList",
        data: data,
        method: "post",
        type: "application/json"
    });
};

//   查看用户数据
const getUserInfoVO = data => {
    return request_wxrlxf({
        url: "/api/appointmentApi/getUserInfoVO",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   营业执照OCR数据获取
const getOCRDetail = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getOCRDetail",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   常客查看公司信息
const userWhiteLookCompanyInfo = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/userWhiteLookCompanyInfo",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   查询公司列表
const getCompanyList = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getCompanyList",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//   通过公司Id查询楼宇和公司信息
const getBuildingAndCompanyInfo = adminId => {
    return request_wxrlxf({
        url: "/api/buildingApi/getBuildingAndCompanyInfo",
        data: {
            adminId: adminId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};

//   校验此常客白名单id是否有效
const checkUserWhiteListId = userWhiteListId => {
    return request_wxrlxf({
        url: "/api/buildingApi/checkUserWhiteListId",
        data: {
            userWhiteListId: userWhiteListId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
// 访客下发
const visitoryDownFaceAgain = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/visitoryDownFaceAgain",
        data: data,
        method: "get",
        type: "application/json"
    });
};
// 获取访客qrcodeId
const getVisitorQrcodeId = data => {
    return request_wxrlxf({
        url: "/api/buildingApi/getVisitorQrcodeId",
        data: data,
        method: "post",
        type: "application/json"
    });
};
module.exports = {
    doPass,
    userWhiteGetSnList,
    getBuildingList,
    getVisitoryByUserVisitorListDetailId,
    userWhiteInviteUserVisitor,
    userWhiteCheck,
    getUserWhiteByphoneAndAdminId,
    visitorySubmit,
    companyCommit,
    companyCommitInfoList,
    userWhiteVisitList,
    userWhiteHandleVisitList,
    getUserInfoVO,
    getOCRDetail,
    visitoryVisitList,
    userWhiteLookCompanyInfo,
    getCompanyList,
    getBuildingAndCompanyInfo,
    checkUserWhiteListId,
    visitoryDownFaceAgain,
    getVisitorQrcodeId
};
