const _my = require("../../__antmove/api/index.js")(my);
const wx = _my;
const { request_wxrlxf } = require("../func/request");
const doPass = data => {
    return request_wxrlxf({
        url: "/api/next/doGetFacePass",
        data: data,
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//获取是否有自定义字段
const getContextByAdminId = orgId => {
    return request_wxrlxf({
        url: "/api/next/getContextByAdminId",
        data: {
            adminId: orgId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};

//获取用户填写的自定义字段内容
const selectContextByCardId = (orgId, userId) => {
    return request_wxrlxf({
        url: "/api/next/selectContextByCardId",
        data: {
            adminId: orgId,
            id: userId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};

//提交自定义字段填写结果
const InsertContentByCardId = data => {
    return request_wxrlxf({
        url: "/api/next/InsertContentByCardId",
        data: data,
        method: "post",
        type: "application/json"
    });
};
//获得省份列表
const getProvince = () => {
    return request_wxrlxf({
        url: "/api/next/getProvince",
        data: {},
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//获得城市列表
const getCity = areaCodeId => {
    return request_wxrlxf({
        url: "/api/next/getCity",
        data: {
            areaCodeId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//获得区县列表
const getArea = areaCodeId => {
    return request_wxrlxf({
        url: "/api/next/getArea",
        data: {
            areaCodeId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
//获得街道列表
const getStreet = areaCodeId => {
    return request_wxrlxf({
        url: "/api/next/getStreet",
        data: {
            areaCodeId
        },
        method: "get",
        type: "application/x-www-form-urlencoded"
    });
};
module.exports = {
    doPass,
    getContextByAdminId,
    selectContextByCardId,
    InsertContentByCardId,
    getProvince,
    getCity,
    getArea,
    getStreet
};
